MacroScript NoteTrack_Extractor category:"Bobo_s Tools"
(

-------------------------------------------------------------------------------
--	 Name:			NoteTrack_Extractor
--	 Version:		v0.1
--	 Started:       10/28/99
--	 Last Modified: 10/28/99
--   Description:	Extracts NoteTracks for the NoteTrack_Importer script
--	 Code by:		Borislav Petrov [Boboland]		bobo@email.archlab.tuwien.ac.at
-------------------------------------------------------------------------------

out_path = getSaveFileName caption:"Save NoteTracks As" filename:(scriptspath+"NoteExtractorFile.ntk") types:"NoteTrack (.NTK)|*.NTK|All Files (*.*)|*.*|"

if out_path != undefined then
(
out_file = createfile out_path

format "%\n" "[NoteExtractorFile]" to:out_file
format "%\n" "Version 1.0" to:out_file

format "%\n" "[MaxFile]" to:out_file
mfn = MAXFileName
if mfn == "" then mfn = "Untitled"
format "%\n" mfn to:out_file


fn extract_notes top_object sub_object =
(
notes_array = #()
if sub_object == undefined then return false
try
(
if hasNoteTracks sub_object.object then
(
	nnt = numNoteTracks sub_object.object
	for j = 1 to nnt do 
		(
		note_track = getNoteTrack sub_object.object j
		format "%\n" "[TopObject]" to:out_file
		format "%\n" top_object.name to:out_file
		format "%\n" "[SubObject]" to:out_file
		format "%\n" (sub_object as string) to:out_file
		format "%\n" "[NumKeys]" to:out_file
		format "%\n" (note_track.keys.count as string) to:out_file
		for n in note_track.keys do
			(
			format "%\n" "[Time]" to:out_file
			format "%\n" (n.time as string) to:out_file
			format "%\n" "[Note]" to:out_file
			format "%\n" (n.value) to:out_file
			format "%\n" "[EndNote]" to:out_file
			)
		)
)
)
catch()	
)--end fn


objects_array = $* as array
for o in objects_array do
(
sub_array = #()
append sub_array o
counter = 1
while counter <= sub_array.count do
(
try(new_subs = sub_array[counter].numsubs)catch(new_subs = 0)
if new_subs > 0 then
	(
	for i = 1 to new_subs do
		(
		if sub_array[counter][i] != undefined then 
			(
			append sub_array sub_array[counter][i].object
			extract_notes o sub_array[counter][i]
			)
		)
	)
counter += 1
)
)--end o loop

format "%\n" "[EndFile]" to:out_file
close out_file
--edit out_path
)

)--end script
