macroScript NoteTrack_Importer category:"Bobo_s Tools"

(


-------------------------------------------------------------------------------
--	 Name:			NoteTrack_Importer
--	 Version:		v0.2
--	 Started:       10/28/99
--	 Last Modified: 08/04/00
--   Description:	Imports NoteTracks exported by the NoteTracksExtractor script
--	 Code by:		Borislav Petrov [Boboland]		bobo@email.archlab.tuwien.ac.at
-------------------------------------------------------------------------------




global nti_floater
global nti_roll

global note_arrays

global time_arrays

global nti_roll 

global subs_array = #()



fn get_objects_list =

(

in_file = openfile (scriptspath+nti_roll.ext_file_name.text)

top_object_array = #()

while rl != "[EndFile]" do

(

rl = readline in_file

if rl == "[TopObject]" then

	(

	top_object = readline in_file

	if findItem top_object_array top_object == 0 then append top_object_array top_object

	)

)--end while loop

close in_file

top_object_array

)--end fn



fn get_sub_objects_list obj trk=

(

time_arrays = #()

note_arrays = #()



in_file = openfile (scriptspath+nti_roll.ext_file_name.text)

sub_object_array = #()

enable_reading = false

rl = ""

while rl != "[EndFile]" do

(

rl = readline in_file

if rl == "[TopObject]" then

	(

	top_object = readline in_file

	if top_object == obj then

		(

		enable_reading = true

		)

		else

		(

		enable_reading = false

		)

	)

if rl == "[SubObject]" and enable_reading then

	(

	sub_obj = readline in_file

	append sub_object_array sub_obj

	sub_object_index = sub_object_array.count

	time_array = #()

	note_array = #()

	nk = readline in_file

	num_keys = (readline in_file) as integer

	if num_keys > 0 then

		(

		for n = 1 to num_keys do

			(

			t = readline in_file

			time_value = readline in_file

			append time_array time_value

			nt = readline in_file

			track_string = ""

			track_value = ""

			while track_value != "[EndNote]" do

			(

			track_value = readline in_file

			if track_value != "[EndNote]" then 

				(

				track_value += " "

				track_string += track_value 

				)

			)--end while

			append note_array track_string

			)--end n loop

		time_arrays[sub_object_index] = time_array

		note_arrays[sub_object_index] = note_array

	)--end key>0

	else

	(

	time_arrays[sub_object_index] = #()

	note_arrays[sub_object_index] = #()

	)

)--end if

)--end while loop

close in_file

nti_roll.start_key.items = time_arrays[1]

nti_roll.start_key.selection = 1

nti_roll.end_key.items = time_arrays[1]

nti_roll.end_key.selection = time_arrays[1].count

nti_roll.start_key_text.text = note_arrays[1][1]

nti_roll.end_key_text.text = note_arrays[1][note_arrays[1].count]

nti_roll.sub_obj_list.selection = 1



sub_object_array



)--end fn



fn collect_subs obj =

(

o_node = execute ("$'"+obj+"'")

subs_array = #()

append subs_array o_node

counter = 0

name_subs_array = #()



while counter < subs_array.count do

	(

	counter += 1

	try(ns = subs_array[counter].numsubs) catch(ns = 0)

	for n = 1 to ns do 

		(

		append subs_array subs_array[counter][n].object

		append name_subs_array (subs_array[counter][n] as string)

		)

	)

name_subs_array

)



fn scan_for_sub obj sub =

(

o_node = execute ("$'"+obj+"'")

temp_subs_array = #()

append temp_subs_array o_node

counter = 0



while counter < subs_array.count do

	(

	counter += 1

	try(ns = temp_subs_array[counter].numsubs) catch(ns = 0)

	for n = 1 to ns do 

		(

		if temp_subs_array[counter][n] as string == sub then 

			(

			return temp_subs_array[counter][n].object

			exit

			)

		append temp_subs_array temp_subs_array[counter][n].object

		)

	)

undefined	

)





rollout nti_roll "NoteTrack Importer"

(

group "Source File"

(

button get_read_file ">Select NoteTrackExtractor File<" width:200

edittext ext_file_name "Extractor File:" text:"" fieldwidth:110 align:#right

edittext max_file_name "Source MAX File:" text:"" fieldwidth:110 align:#right

)

group "Source Note Tracks"

(

dropdownlist top_obj_list "Top Object" items:#() align:#right

dropdownlist sub_obj_list "Sub Object Track" items:#() align:#right

dropdownlist start_key "Start Key" items:#() align:#right

edittext start_key_text text:"" fieldwidth:198 align:#right

dropdownlist end_key "End Key" items:#() align:#right

edittext end_key_text text:"" fieldwidth:198 align:#right

)

group "Target"

(

pickbutton pick_target ">Pick Target From Scene<" width:140 across:2 align:#left

checkbutton auto_target "Auto" width:55 align:#right checked:true highlightcolor:(color 200 255 200)



dropdownlist target_obj_list "Target Object" items:#() align:#right

dropdownlist target_sub_obj_list "Target Sub Object Track" items:#() align:#right

)

button assign_to_object "ASSIGN TO TARGET OBJECT" width:200 height:25 enabled:false





on assign_to_object pressed do

(

new_track = noteTrack "NewNoteTrack"

new_track_array = new_track.keys

for k = start_key.selection to end_key.selection do

	(

	time_value = execute time_arrays[sub_obj_list.selection][k]

	addNewNoteKey new_track_array time_value

	note_string = note_arrays[sub_obj_list.selection][k]

	

	new_track_array[new_track_array.count].value = note_string

	)

source_obj = target_obj_list.items[target_obj_list.selection]

source_node_sub = scan_for_sub source_obj target_sub_obj_list.items[target_sub_obj_list.selection]

if source_node_sub != undefined then 

	(

	addNoteTrack source_node_sub new_track

	)

)



fn get_auto_target =

(

if top_obj_list.items.count > 0 then

(

source_obj = top_obj_list.items[top_obj_list.selection]

source_node = execute ("$'"+source_obj+"'")

if source_node != undefined then 

	(

	items_array = target_obj_list.items

	array_index = findItem items_array source_obj

	if array_index > 0 then target_obj_list.selection = array_index

	cs = collect_subs target_obj_list.items[target_obj_list.selection]

	nti_roll.target_sub_obj_list.items = cs

	if sub_obj_list.selection >0 then

		(

		for n = 1 to target_sub_obj_list.items.count do

		(

		if target_sub_obj_list.items[n] == sub_obj_list.items[sub_obj_list.selection] then target_sub_obj_list.selection = n

		)

		)

	)

)

)





on auto_target changed state do

(

if state then get_auto_target ()

)



on target_obj_list selected itm do

(

	cs = collect_subs target_obj_list.items[itm]

	nti_roll.target_sub_obj_list.items = cs

)



on pick_target picked obj do

(

if obj != undefined then 

	(

	items_array = target_obj_list.items

	array_index = findItem items_array obj.name

	if array_index > 0 then target_obj_list.selection = array_index

	cs = collect_subs target_obj_list.items[target_obj_list.selection]

	nti_roll.target_sub_obj_list.items = cs

	)

)



on start_key selected itm do

(

start_key_text.text = note_arrays[sub_obj_list.selection][itm]

)



on end_key selected itm do

(

end_key_text.text = note_arrays[sub_obj_list.selection][itm]

)



on get_read_file pressed do

(

in_path = getOpenFileName caption:"Get NoteTrack File" filename:(scriptspath+"NoteExtractorFile.ntk") types:"NoteTrack (.NTK)|*.NTK|All Files (*.*)|*.*|"

if in_path != undefined then

(

in_file = openfile in_path

rl = readline in_file 

if rl != "[NoteExtractorFile]" then

(

messagebox "Not a Valid NoteExtractor File!" title:"NoteImporter"

)

else

(

ext_file_name.text = filenamefrompath in_path

rl = readline in_file	--read Version Number (not used yet)

rl = readline in_file

mfn = readline in_file

max_file_name.text = mfn

close in_file

top_obj_list.items = get_objects_list ()

obj = top_obj_list.items[1]

sub_obj_list.items = get_sub_objects_list obj 1

assign_to_object.enabled=true

if auto_target.checked then get_auto_target ()

)--end if

)

)



on top_obj_list selected itm do

(

obj = top_obj_list.items[itm]

sub_obj_list.items = get_sub_objects_list obj sub_obj_list.selection

if auto_target.checked then get_auto_target ()

)



on sub_obj_list selected itm do

(

sub_obj_list.items = get_sub_objects_list (top_obj_list.items[top_obj_list.selection]) itm

if auto_target.checked then get_auto_target ()

)



)--end roll



if nti_floater != undefined then closerolloutfloater nti_floater

nti_floater = newrolloutfloater "NoteTrack Importer" 250 600 10 10

addrollout nti_roll nti_floater

scene_obj_array = for i in $* collect i.name
if scene_obj_array.count == 0 then
	(
	closerolloutfloater nti_floater
	messagebox "You need at least one object\nin the scene to run this script." title:"NoteTrack Importer"
	)
	else
	(

	nti_roll.target_obj_list.items = scene_obj_array

	cs = collect_subs scene_obj_array[1]

	nti_roll.target_sub_obj_list.items = cs
	)





)--end script
